# Rules.make for uClibc test apps.
#
# Copyright (C) 2001 by Lineo, inc.
#
#
#Note: This does not read the top level Rules.mak file
#

include $(BRECIS_ROOT)/ProductConfig
include $(BRECIS_ROOT)/ProductLanguage

#ifdef LANGUAGE_GERMAN
#include "language.German.h"
#else
#ifdef LANGUAGE_JAPANESE
#include "language.Japanese.h"
#else
#ifdef LANGUAGE_CHINESE_SIMP
#include "language.ChineseSimp.h"
#else
#ifdef LANGUAGE_CHINESE_TRAD

ifeq ($(LANGUAGE), English)
	INSTALL_PATH_BIN = $(BRECIS_ROOT)/prods/romdisk/English/bin
	CFLAGS +=  -DLANGUAGE_ENGLISH
endif

#INSTALL_PATH_BIN = $(BRECIS_ROOT)/prods/romdisk/bin
STRIP_CMD = mips-strip -x --strip-unneeded -R .comment -R .pdr -R .note -R .mdebug.abi32 -R .toss

# by jkglee
UCLIBCDIR = $(BRECIS_ROOT)/$(GB_LIBC_VERSION)
#UCLIBCDIR = /home/jkglee/BRECIS/uClibc-brecis-0.9.15
include $(UCLIBCDIR)/extra/Configs/Config.brecis

# by jkglee
DODEBUG = false
DODYNAMIC = false

# by jkglee
CFLAGS += -I$(APPSTOP)../include -w

# Use NATIVE_ARCH here since running these test is not
# even possible when cross compiling...
NATIVE_ARCH:= ${shell uname -m | sed \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234].*/sh/' \
		-e 's/mips.*/mips/' \
		}
ifeq ($(strip $(TARGET_ARCH)),)
TARGET_ARCH_X :=${shell $(CC) -dumpmachine | sed -e s'/-.*//' \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234]/sh/' \
		-e 's/mips.*/mips/' \
		}
endif


# If you are running a cross compiler, you may want to set this
# to something more interesting...
# by jkglee
CC = $(UCLIBCDIR)/extra/gcc-uClibc/mips-uclibc-gcc
HOST_CC = gcc
STRIPTOOL=strip
# by jkglee
#LDD = ../$(TESTDIR)ldso/util/ldd


# Check if 'ls -sh' works or not
LSFLAGS = -l

# turn all the warnings on
WARNINGS=-Wall

# use '-Os' optimization if available, else use -O2
OPTIMIZATION = ${shell if $(CC) -Os -S -o /dev/null -xc /dev/null >/dev/null 2>&1; \
    then echo "-Os"; else echo "-O2" ; fi}

ifeq ($(DODEBUG),true)
    CFLAGS +=$(WARNINGS) $(OPTIMIZATION) -g
    GLIBC_CFLAGS +=$(WARNINGS) $(OPTIMIZATION) -g
    LDFLAGS =-Wl,-q
    #LDFLAGS =-Wl,-warn-common
    #LDFLAGS =-Wl,-elf2flt
    GLIBC_LDFLAGS =-Wl,-warn-common 
    STRIPTOOL =/bin/true -Since_we_are_debugging
else
    CFLAGS  +=$(WARNINGS) $(OPTIMIZATION) -fomit-frame-pointer
    GLIBC_CFLAGS  +=$(WARNINGS) $(OPTIMIZATION) -fomit-frame-pointer
    LDFLAGS  =-s -Wl,-q
    #LDFLAGS  =-s -Wl,-warn-common
    #LDFLAGS =-Wl,-elf2flt
    GLIBC_LDFLAGS  =-s -Wl,-warn-common
    STRIP    = $(STRIPTOOL) --remove-section=.note --remove-section=.comment $(PROG)
endif

ifneq ($(DODYNAMIC),true)
    LDFLAGS +=--static
    GLIBC_LDFLAGS +=--static
endif
CFLAGS+=--uclibc-use-build-dir
LDFLAGS+=--uclibc-use-build-dir

ifeq ($(HAS_MULTI_SESSION),y)
	CFLAGS += -DHAS_MULTI_SESSION
endif

ifeq ($(HAS_UPNP),y)
	CFLAGS += -DHAS_UPNP
endif

ifeq ($(HAS_RIP),y)
	CFLAGS += -DHAS_RIP
endif

ifeq ($(HAS_DDNS),y)
	CFLAGS += -DHAS_DDNS
endif

ifeq ($(HAS_URLBLOCKING),y)
	CFLAGS += -DHAS_URLBLOCKING
endif


ifeq ($(ENABLE_PNP_SETUP),y)
	CFLAGS += -DENABLE_PNP_SETUP
endif
