#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <syslog.h>
#include <signal.h>
#include <errno.h>
#include <getopt.h>
#include <time.h>

#include "libgigarouter.h"
#include "gigaconfig.h"

#define REMAINING 0
#define ABSOLUTE 1

struct lease_t {
	unsigned char chaddr[16];
	u_int32_t yiaddr;
	u_int32_t expires;
	u_int32_t static_f;
};

int main (int argc, char *argv[]) {
	FILE *fp,*Htmlfile;
	int i, c, mode = REMAINING;
	long expires;
	char file[255] = "/ramdisk/etc/udhcpd.leases";
	char Hfile[255]= "/ramdisk/htdocs/dhcp.lease.html";
	char Mactemp[2]="";
	char MAC[32]="";
	struct lease_t lease;
	struct in_addr addr;
	int udhcpd_pid;
	static struct option options[] = {
		{"absolute", 0, 0, 'a'},
		{"remaining", 0, 0, 'r'},
		{"file", 1, 0, 'f'},
		{"help", 0, 0, 'h'},
		{0, 0, 0, 0}
	};
	
	char szBack[] = { 0x96, 0xDF, 0x82, 0xE9, 0x00 };
	
	int nResult = 0;
	char szBuffer[4];
	
        //storm / 2002.10.24 / Send signal to udhcpd for write leases file.
	//otherwise renew leases file will depend auto-time option(7200sec.)
	fp=fopen("/var/run/udhcpd.pid","r");
	if(fp!=NULL)
	   {
         fscanf(fp,"%d", &udhcpd_pid);
         kill(udhcpd_pid,SIGUSR1);
         fclose(fp);
	    }
	
	//else  fclose(fp);

	while (1) {
		int option_index = 0;
		c = getopt_long(argc, argv, "arf:h", options, &option_index);
		if (c == -1) break;

		switch (c) {
		case 'a': mode = ABSOLUTE; break;
		case 'r': mode = REMAINING; break;
		case 'f':
			strncpy(file, optarg, 255);
			file[254] = '\0';
			break;
		case 'h':
			printf("Usage: dumpleases -f <file> -[ra]\n\n");
			printf("  -f, --file=FILENAME             Leases file to load\n");
			printf("  -r, --remaining                 Interepret lease times as time reemaing\n");
			printf("  -a, --absolute                  Interepret lease times as expire time\n");
			break;
		}
	}

	if (!(fp = fopen(file, "r"))) {
		perror("could not open input file");
		return 0;
	}
	if (!(Htmlfile = fopen(Hfile, "w"))) {
		perror("could not open HTML file");
		return 0;
	}

	//HTML HEAD
      fprintf(Htmlfile,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"><HTML><HEAD><TITLE>(null)</TITLE>\n");
      fprintf(Htmlfile,"<META http-equiv=Content--Style-Type content=text/css>\n");
      fprintf(Htmlfile,"<META http-equiv=Content-Type content=\"text/html; charset=x-sjis\">\n");
      fprintf(Htmlfile,"<META content=\"Microsoft FrontPage 4.0\" name=GENERATOR>\n");
      fprintf(Htmlfile,"<STYLE type=text/css>A {TEXT-DECORATION: none}A:hover {COLOR: red}\n");
      fprintf(Htmlfile,"</STYLE></HEAD><BODY bgColor=#ffffff background=DhcpTable.files/tile_w.gif>\n");
      fprintf(Htmlfile,"<P align=left><TABLE cellSpacing=1 cellPadding=1 width=560>\n");
      fprintf(Htmlfile,"<TBODY><TR><TD vAlign=center width=\"100%%\" bgColor=#00ccff height=20>\n");
      fprintf(Htmlfile,"<P align=left><FONT lang=JA size=3><STRONG>DHCP Lease Table</A></STRONG></FONT></P></TD></TR></TBODY></TABLE>\n");
      fprintf(Htmlfile,"<TABLE cellSpacing=1 cellPadding=1 width=560><TBODY>\n");


	printf("Mac Address       IP-Address      Expires %s\n", mode == REMAINING ? "in" : "at");
	/*     "00:00:00:00:00:00 255.255.255.255 Wed Jun 30 21:49:08 1993" */
	//storm / 2002.10.24 / Create DHCPD Leases HTML file
	//Title
      fprintf(Htmlfile,"<TR><TD width=\"20%%\"><P align=left><FONT lang=JA size=2><STRONG>IP Address</STRONG></FONT></P></TD>\n");
      fprintf(Htmlfile,"<TD width=\"20%%\"><P align=left><FONT lang=JA size=2><STRONG>MAC Address</STRONG></FONT></P></TD>\n");
      fprintf(Htmlfile,"<TD width=\"60%%\"><P align=left><FONT lang=JA size=2><STRONG>TTL</STRONG></FONT></P></TD></TR>\n");

      // by jkglee, 2003.01.23, for dhcp daemon disable ...      
      nResult = GIGA_GetSystemSetting("DHCP_SERVER", "dhcpd_enable", szBuffer, 4, RW_ITEM_MODE); 
      if ( (nResult == 0) && (szBuffer[0] == '0') )
          goto DHCPD_DISABLE;
      
	while (fread(&lease, sizeof(lease), 1, fp)) {

		if ((lease.static_f == 1) &&
		    (lease.expires == 0xffffffff))
		{
			continue;
		}
	       	 
		strcpy(MAC,"");
		
		for (i = 0; i < 6; i++) {
			printf("%02x", lease.chaddr[i]);
			sprintf(Mactemp,"%02x", lease.chaddr[i]);
			strcat(MAC,Mactemp);
			if (i != 5) {printf(":");strcat(MAC,":");}
		}
          
	  	if(!strncmp(MAC,"00:00:00:00:00:00",17))
		   continue;

		addr.s_addr = lease.yiaddr;
		printf(" %-15s", inet_ntoa(addr));
	//IP address
        fprintf(Htmlfile,"<TD width=\"20%%\"><P align=left><FONT lang=JA size=2>%-15s</FONT></P></TD>\n", inet_ntoa(addr));
	//MAC address
        fprintf(Htmlfile,"<TD width=\"20%%\"><P align=left><FONT lang=JA size=2>%s</FONT></P></TD><TD width=\"60%%\">\n",MAC);
		expires = ntohl(lease.expires);
		printf(" ");
		if (mode == REMAINING) {
			if (!expires) {
			fprintf(Htmlfile,"<P align=left><FONT lang=JA size=2>expired");
			printf("expired\n");
                        fprintf(Htmlfile,"</FONT></P></TD></TR>");
			}
			else { 
				        fprintf(Htmlfile,"<P align=left><FONT lang=JA size=2>");
				if (expires > 60*60*24) {
					printf("%ld days, ", expires / (60*60*24));
					fprintf(Htmlfile,"%ld days,",expires / (60*60*24));
					expires %= 60*60*24;
				}
				if (expires > 60*60) {
					printf("%ld hours, ", expires / (60*60));
                                        fprintf(Htmlfile,"%ld hours,",expires / (60*60));
					expires %= 60*60;
				}
				if (expires > 60) {
					printf("%ld minutes, ", expires / 60);
					fprintf(Htmlfile,"%ld minutes,",expires / 60 );
					expires %= 60;
				}
				printf("%ld seconds\n", expires);
                                fprintf(Htmlfile,"%ld seconds",expires);	
                                fprintf(Htmlfile,"</FONT></P></TD></TR>");
 			}
		} else printf("%s", ctime(&expires));
	}
	fclose(fp);

DHCPD_DISABLE:

        //fprintf(Htmlfile,"<TD><BR></TD></TR></TBODY></TABLE><TABLE cellSpacing=1 cellPadding=1 width=560><TBODY>\n");
        fprintf(Htmlfile,"<TD><BR></TD></TR></TBODY></TABLE><FORM><TABLE cellSpacing=1 cellPadding=1 width=560><TBODY>\n");
        fprintf(Htmlfile,"<TR><TD width=\"100%%\"><HR></TD></TR><TR><TD width=\"100%%\">\n");
        fprintf(Htmlfile,"<DIV align=center><INPUT onclick=history.back(); type=button value=%s>\n", szBack);
        //fprintf(Htmlfile,"</DIV></TD></TR></TBODY></TABLE></BODY></HTML>\n");
        fprintf(Htmlfile,"</DIV></TD></TR></TBODY></TABLE></FORM></BODY></HTML>\n");

	fclose(Htmlfile);

	return 0;
}
