/*
 $Header: /home/cvsroot/B49G/linux-brecis-2.4.20/drivers/net/phy8721.c,v 1.1.1.1 2004/04/29 09:53:56 jkglee Exp $
 */

/******************************************************************
 * Copyright (c) 2002,2003 BRECIS Communications
 *
 *     This program is free software; you can redistribute it
 *     and/or modify it under the terms of the GNU General
 *     Public License as published by the Free Software
 *     Foundation; either version 2 of the License, or (at your
 *     option) any later version.
 *
 *     This program is distributed in the hope that it will be
 *     useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with this program; if not, write to the Free
 *     Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
 *     02139, USA.
 *
 * BRECIS COMMUNICATIONS DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS
 * SOFTWARE.
 */


#include "brecismspeth.h"
#include "phyethgeneric.h"
#include "phy8721.h"


/*************************************************************************
 * MSPPHY8721HandleInt - Handles the interrupt from the PHY 8721.
 */

int	MSPPHY8721HandleInt(MSP_DEVICE *pDrvCtrl)
{
	int	data;

	/*
	 * Read the ISR of the PHY8721 to determine the cause of the interrupt.
	 */
	data = readPhyRegister(pDrvCtrl, PHY8721_INTERRUPT_CONTROL_STATUS);

	if (data & PHY8721b_INTERRUPT_LINK_DOWN)
		return MSP_MAC_PHY_NO_LINK;

	if (data & PHY8721b_INTERRUPT_LINK_UP)
		return MSPPHYGGetSpeedAndDuplex(pDrvCtrl);

	return MSP_SUCCESS;
}

