/*
 $Header: /home/cvsroot/B49G/linux-brecis-2.4.20/drivers/net/phy971.c,v 1.1.1.1 2004/04/29 09:53:56 jkglee Exp $
 */

/******************************************************************
 * Copyright (c) 2002,2003 BRECIS Communications
 *
 *     This program is free software; you can redistribute it
 *     and/or modify it under the terms of the GNU General
 *     Public License as published by the Free Software
 *     Foundation; either version 2 of the License, or (at your
 *     option) any later version.
 *
 *     This program is distributed in the hope that it will be
 *     useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with this program; if not, write to the Free
 *     Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
 *     02139, USA.
 *
 * BRECIS COMMUNICATIONS DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS
 * SOFTWARE.
 */

#include "brecismspeth.h"
#include "phyethgeneric.h"
#include "phy971.h"


/*************************************************************************
 * MSPPHY971DuplexIntEnable - Enables the Duplex change Interrupt for the PHY 971
 *
 * RETURNS:N/A
 */

void	MSPPHY971DuplexIntEnable(MSP_DEVICE *pDrvCtrl)
{
	/* Send the data to the PHY */
   	if (writePhyRegister(pDrvCtrl, PHY971_INTERRUPT_ENABLE, 
			     PHY971_INTERRUPT_ENABLE_DUPLEXMSK))
	{
		printk(KERN_INFO "MSPPHY971DuplexIntEnable:  PHY BUSY PHY971_INTERRUPT_ENABLE\n");
		return;
	}
}



/*************************************************************************
 * MSPPHY971HandleInt - Handles the interrupt from the PHY 971.
 *
 * RETURNS:N/A
 */

int	MSPPHY971HandleInt(MSP_DEVICE *pDrvCtrl)
{
	int	data, srdata;

	/*
	 * Read the ISR of the PHY971 to determine the cause of the interrupt.
	 */
	data = readPhyRegister(pDrvCtrl, PHY971_INTERRUPT_STATUS);

	/* 
	 * Read status register 2 has status of PHY at this time 
	 */
   	srdata = readPhyRegister(pDrvCtrl, PHY971_STATUS_REG_TWO);

	if (data & PHY971_INTERRUPT_STATUS_LINKCHG)
	{
		if ((srdata & PHY971b_STATUS_REG_TWO_LINK) == 0)
		{
			/* We no longer have a link */
			/* Should really mark the interface down */
			return MSP_MAC_PHY_NO_LINK;
		}
	}

	return MSPPHYGGetSpeedAndDuplex(pDrvCtrl);
}

