/*=======================================================================
; Comment: Java Script for triming data
; IN : Orignal Data String
; OUT: Trim Data String
; Important algorithm:
; Author:Jason Lan
; Time: 2003/03/31
; Original Reference: KME project
;========================================================================*/
function Trim(s)
{
    s1=new String(s);
    var s2;

    for(var i=0;i<s1.length;i++){
        if(s1.charAt(i)!=" " && s1.charAt(i)!="@"){
            break;
        }else{
            /* do nothing */
        }
    }

    s2=s1.substring(i,s1.length);

    for(var i=s2.length-1;i>=0;--i){
        if(s2.charAt(i)!=" " && s2.charAt(i)!="@"){
            break;
        }else{
            /* do nothing */
        }
    }

    s2=s2.substring(0,((i==-1)?0:i)+1);

    return s2;
}

/*=======================================================================
; Comment: Java Script for escape special string
; IN : Data String
; OUT: 0:String not exceed
; Important algorithm:
; Author:Jason Lan
; Time: 2003/03/31
; Original Reference: KME project
;========================================================================*/
function escape2(str)
{
    HexT = '0123456789ABCDEF';
    ret  = '';
    for(i = 0; i < str.length; i++){
        c = str.charAt(i);
        if(c.search(/[\*\-\.0-9A-Z_a-z@]/) < 0){
            cc = c.charCodeAt(0);
            ccc = '';
            while(cc > 0){
                ccc = HexT.charAt(cc & 0xf) + ccc;
                cc >>>= 4;
            }
            if(ccc.length == 0){
                ccc = '00';
            }else if(ccc.length % 2){
                ccc = '0' + ccc;
            }
            if(ccc.length == 4){
                ccc = '%u' + ccc;
            }else{
                ccc = '%'  + ccc;
            }
            ret += ccc;
        }else{
            ret += c;
        }
    }
    return ret;
}

/*=======================================================================
; Comment: Java Script for checking special string Length
; IN : Data String
; OUT: 0:String not exceed
; Important algorithm:
; Author:Jason Lan
; Time: 2003/03/31
; Original Reference: KME project
;========================================================================*/
function SpecStrLen(str)
{
    var len = 0;
    str = escape2(str);
    for(var i = 0; i < str.length; i++, len++){
        if(str.charAt(i) == "%"){
            if(str.charAt(++i) == "u"){
                i += 3;
                len++;
            }else{
                /* do nothing */
            }
            i++;
        }else{
            /* do nothing */
        }
    }
    return len;
}

/*=======================================================================
; Comment: Java Script for checking record name Length
; IN : Data String, Maximum Length
; OUT: 0:String not exceed
; Important algorithm:
; Author:Jason Lan
; Time: 2003/03/31
; Original Reference: KME project
;========================================================================*/
function StrLenCheck(str_data, maxlen)
{
    var str_s = str_data.value;
    var len = SpecStrLen(str_s);
    if(len > maxlen){
        return len-maxlen;
    }else{
        return 0;
    }
}

/*=======================================================================
; Comment: Java Script for checking record name(ISP Name)
; IN : Data String, Maximum Length
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/03/31
; Original Reference: KME project
;========================================================================*/
function CheckISPName(str_data, maxlen)
{
    var flag=false;
    if(str_data.value == ""){
        return false;
    }else{
        var str_s = Trim(str_data.value);
        str_data.value = str_s;
        if(str_s == ""){
            alert("Please input ISP Name.");
            return false;
        }else{
            /* do nothing */
        }
        
        if(str_s.match(/\"/)){
            flag = false;
            alert("Invalid ISP Name ("+str_s.match+").");
            str_data.value = "";
        }
	else{
	    flag = StrLenCheck(str_data, maxlen);
	    if(flag == 0){
	        flag = true;
	    }
	    else{
	        alert("ISP Name Excess "+flag+" words.");
	        flag = false;
	    }
	}
    }
	return flag;
}

/*=======================================================================
; Comment: Java Script for checking Text Type
; IN : Data String
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckText(text)
{
    var name = text.value;
    var flag;
    
    if(name.match(/[\ \"]/)){
        flag = false;
        alert("Invalid Text ( "+text.value+" ).");
        text.value="";
    }else{
        flag = true;
    }
    return flag;
}

/*=======================================================================
; Comment: Java Script for Netmask Type
; IN : Data String
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckNetmaskType( argPrefix )
{
    var Prefix = new String( argPrefix );

    if( Prefix=="0" || Prefix=="128" || Prefix=="192" || Prefix=="224" || Prefix=="240" ||  Prefix=="248" || Prefix=="252" || Prefix=="254" || Prefix=="255" ){
        return true;
    }else{
        return false;
    }
}

/*=======================================================================
; Comment: Java Script for Netmask Type
; IN : Data String, Check NULL Flag
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/02
; Original Reference: KME project
;========================================================================*/
function CheckMTU(mtu, NullCheckFlg)
{
    if(NullCheckFlg == 0){
        if(Trim(mtu.value) == ""){
            mtu.value="";
            return true;
        }else{
            /* do nothing */
        }
    }else{
        /* do nothing */
    }
    
    if(!((mtu.value>=576)&&(mtu.value<=1500))){
        alert("MTU range between 576 and 1500.");
        mtu.value='';
        return false;
    }else{
        /* do nothing */
    }
    
    return true;
}

function CheckDOD(mtu, NullCheckFlg)
{
    if(NullCheckFlg == 0){
        if(Trim(mtu.value) == ""){
            mtu.value="";
            return true;
        }else{
            /* do nothing */
        }
    }else{
        /* do nothing */
    }

    if(!((mtu.value>=1)&&(mtu.value<=1440))){
        alert("MTU range between 1 and 1440.");
        mtu.value='';
        return false;
    }else{
        /* do nothing */
    }

    return true;
}
/*=======================================================================
; Comment: Java Script for checking Port number
; IN : Data String
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function NumberCheck( argNumber )
{
    var Number = new String( argNumber );

    for( i = 0; i < Number.length; i++ ){
        if( Number.charAt(i) < '0' || Number.charAt(i) > '9' ){
            return false;
        }else{
            /* do nothign */
        }
    }
    if( Number.charAt(0) == "0" && Number.length > 1){
        return false;
    }else{
        return true;
    }
}

/*=======================================================================
; Comment: Java Script for checking Port range
; IN : Data String
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function PortRangeCheck( argPortNo )
{
    var PortNo = new String( argPortNo );

    if( PortNo < 0 || PortNo > 65535 ){
        return false;
    }else{
        return true;
    }
}

/*=======================================================================
; Comment: Java Script for checking Port
; IN : Port Data String, Check NULL Flag, Error Message Flag
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckPort(port, NullCheckFlg, err_mess)
{
    var port_value = new String();
    var pointadd1=0;
    var pointadd2=0;
    var pointno=0;
    var str1 = new String();
    var PortNo = new Array();
    var	i;
    var	sp;
    var flag;
    
    port_value = Trim( port.value );
    if(NullCheckFlg == 0){
        if(Trim(port_value) == ""){
            port.value="";
            return true;
        }else{
            /* do nothing  */
        }
    }else{
        /* nithing*/
    }
    sp = 0;
    flag = "";
    if(port_value.charAt(0) == '*' && port_value.length == 1){
        return true;
    }else{
        for( i = 0 ; i < port_value.length; i++ ){
            str1 = port_value.substring( i, i + 1 );
            if( str1 == '-'){
                pointadd2 = i;
                PortNo[sp] = port_value.substring( pointadd1, pointadd2 );
                sp++;
                if( sp > 1 ){
                    flag = "error1";
                    break;
                }else{
                    /* do nothing */
                }
                pointadd1 = pointadd2 + 1;
            }else{
                /* do nothing */
            }
        }
        pointadd2 = i;
        PortNo[sp] = port_value.substring( pointadd1, pointadd2 );
        if( flag == "" ){
            for( i = 0; i <= sp; i++ ){
                if( NumberCheck( PortNo[i] ) == false ){
                    flag = "error2";
                    break;
                }else if( PortRangeCheck( PortNo[i] ) == false ){
                    flag = "error3";
                    break;
                }else if( Trim( PortNo[i] ) == "" ){
                    flag = "error2";
                    break;
                }else{
                    if( i > 0 ){
                        if( parseInt( PortNo[i - 1] ) > parseInt( PortNo[i] ) ){
                            flag = "error2";
                            break;
                        }else{
                            /* do nothing */
                        }
                    }else{
                        /* do nothign */
                    }
                }
            }
        }else{
            /* do nothing */
        }
        if( flag != "" ){
            if(err_mess){
                if( flag == "error1" ){
                    alert( "Invalid Port Inport" );
                    port.value = "";
                }else if( flag == "error2" ){
                    alert( "Invalid Port Number");
                    port.value = "";
                }else if( flag == "error3" ){
                    alert( "Invalid Port Range (0 - 65535)");
                    port.value = "";
                }else{
                    /* do nothing */
                }
            }else{
                /* do nothing */
            }
            return false;
        }else{
            /* do nothing */
        }
        return true;
    }
}
        
