/*=======================================================================
; Comment: Java Script for checking VirtualServer 1 
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckVirtualServer1(form)
{
    if(!CheckIPAddress(form.dmz_ip, 0, 1)){
        return false;
    }else{
        return true;
    }
}
/*=======================================================================
; Comment: Java Script for checking VirtualServer 2 & 3 NAPT Protocol selection
; IN : protocol selection, port text
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckNaptProto(protocol, port)
{
    if( (protocol.value == "4") || (protocol.value == "5") || (protocol.value == "6") ){
        port.value = "*";
    }else{
        /* do nothing */
    }
}

/*=======================================================================
; Comment: Java Script for checking VirtualServer 2 NAPT Prot Input
; IN : port text, protocol selection, Error Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckNaptPort2(port, protocol, err_mess)
{
    if(((protocol.value == "4") || (protocol.value == "5")) && (port.value != "*")){
        port.value="*";
        alert("Invalid Prot Input for GRE and EPS Protocol.");
        return false;
    }else{
        return CheckPort(port, 1, err_mess);
    }
}

/*=======================================================================
; Comment: Java Script for checking VirtualServer 2
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckVirtualServer2(form)
{
    for(var i = 1; i < 17; i++){
        var enable_s = eval("form.enable"+i);
        var proto_s = eval("form.proto"+i);
        var port_s = eval("form.port"+i);
        var ipaddr_s = eval("form.ipaddr"+i);
        if(enable_s[1].selected){
            if(proto_s[0].selected){
                alert("Please select "+i+" protocol.");
                return false;
            }else if(CheckNaptPort2(port_s, 1, 0) != true){
                alert(i+" Port Error");
                return false;
            }else if(!CheckIPAddress(ipaddr_s, 1, 0)){
                alert(i+" IP Address Error.");
                return false;
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking VirtualServer 3 NAPT Prot Input
; IN : port text, protocol selection, Error Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckNaptPort3(port, protocol, err_mess)
{
    if(((protocol.value == "4") || (protocol.value == "5") || (protocol.value == "6")) && (port.value != "*")){
        port.value="*";
        alert("Invalid Prot Input for GRE and EPS Protocol.");
        return false;
    }else{
        return CheckPort(port, 1, err_mess);
    }
}

/*=======================================================================
; Comment: Java Script for checking VirtualServer 3
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckVirtualServer3(form)
{
    for(var i = 1; i < 17; i++){
        var enable_s = eval("form.enable"+i);
        var wanip_s = eval("form.wanipaddr"+i);
        var proto_s = eval("form.proto"+i);
        var port_s = eval("form.port"+i);
        var lanip_s = eval("form.lanipaddr"+i);
        
        if(enable_s[1].selected){
            if(!CheckIPAddress(wanip_s, 1, 0)){
                alert(i+" WAN IP Address Error.");
                return false;
            }else if(proto_s[0].selected){
                alert("Please select "+i+" protocol.");
                return false;
            }else if(!CheckNaptPort3(port_s, proto_s, 0)){
                alert(i+" Port Error");
                return false;
            }else if(!CheckIPAddress(lanip_s, 1, 0)){
                alert(i+" LAN IP Address Error.");
                return false;
            }else{
                /* do nothing */
            }
        }else{
            /* do noting */
        }
    }
}
